package  
{
	import flare.basic.*;
	import flare.core.*;
	import flare.loaders.*;
	import flare.system.*;
	import flash.display.*;
	import flash.events.*;
	import flash.media.*;
	import flash.net.*;
	import flash.utils.*;
	
	[SWF(width = 800, height = 450, backgroundColor = 0xcf7575, frameRate = 60)]
	/**
	 * @author Ariel Nehmad
	 */
	public class Main extends Sprite
	{
		[Embed(source = "assets/heart.zf3d", mimeType = "application/octet-stream")]
		private var Heart:Class;
		[Embed(source = "assets/font1.zf3d", mimeType = "application/octet-stream")]
		private var Font:Class;
		[Embed(source = "assets/font1.fnt", mimeType = "application/octet-stream")]
		private var FontDesc:Class;
		
		private var scene:Scene3D;
		private var model:Pivot3D;
		private var heart:Pivot3D;
		private var particles0:Particles3D;
		private var particles1:Particles3D;
		
		private var chars:Pivot3D;
		private var font:Font3D;
		
		public var spinX:Number = 0;
		public var spinY:Number = 0;
		public var angleY:Number = 0;
		public var angleX:Number = 0;
		public var distance:Number = -170;
		public var lookAt:Pivot3D = new Pivot3D();		
		
		public function Main() 
		{
			scene = new Scene3D( this );
			scene.autoResize = true;
			scene.backgroundColor = 0xcf7575;
			scene.camera.setPosition( 70, 50, -170 );
			scene.camera.lookAt( 0, 0, 0 );
			scene.lights.setGamma();
			scene.addEventListener( Scene3D.COMPLETE_EVENT, completeEvent );
			
			model = scene.addChildFromFile( new Heart );
			
			// the font descriptor is generated using the "Bitmap Font Generator" tool
			// a freeware tool available at www.angelcode.com/products/bmfont/
			var desc:XML = XML( new FontDesc );
			
			// the font 3D set is exported from 3ds max using the font3d.ms script 
			// included with this example in assets folder.
			var chars:Flare3DLoader = new Flare3DLoader( new Font );
				chars.load();
			
			font = new Font3D( chars, desc );
			font.setScale( 0.4, 0.4, 0.4 );
			font.z = -30
			font.align = Font3D.ALIGN_CENTER_X + Font3D.ALIGN_CENTER_Y;
			font.text = "Happy\nValentine's\nDay!";
			scene.addChild( font );
		}
		
		private function completeEvent(e:Event):void 
		{
			heart = scene.getChildByName( "Heart" );
			
			particles0 = scene.getChildByName( "Particles0" ) as Particles3D;
			particles1 = scene.getChildByName( "Particles1" ) as Particles3D;
			
			scene.addEventListener( Scene3D.UPDATE_EVENT, updateEvent );
		}
		
		private function updateEvent(e:Event):void 
		{
			var t:Number = getTimer();
			particles0.x = Math.cos( t / 300 ) * 75;
			particles0.y = Math.sin( t / 530 ) * 25;
			particles0.z = Math.sin( t / 300 ) * 45;
			particles1.x = Math.sin( t / 400 ) * 75;
			particles1.y = Math.cos( t / 230 ) * 25;
			particles1.z = Math.cos( t / 400 ) * 45;
			
			if ( Input3D.mouseDown ) {
				spinX += Input3D.mouseXSpeed * 0.1;
				spinY += Input3D.mouseYSpeed * 0.05;
			}
 
			// apply some easing to the rotations.
			spinX *= 0.90;
			spinY *= 0.90;
			angleY += spinX;
			angleX += spinY;
 
			// clamp ther camera with angles and add some friction to the rotation.
			if ( angleX < -10 ) angleX = -10;
			angleX *= 0.9
			angleY *= 0.9
 
			// set the camera rotation and position.
			lookAt.setRotation( angleX, angleY - 20, 0 );
			scene.camera.copyTransformFrom( lookAt );
			scene.camera.translateZ( distance );			
		}
	}
}