-- This scripts generates all chars in a way that can be
-- used later to generate dynamic 3D text.
-- Just execute the script and export the result to Flare3D.

-- type the font name here.
font = "Edwardian Script ITC"

italic = false
size = 80
alignment = 1
steps = 2

-- this is the extrude modifier for all chars.
ex = extrude()
ex.amount = 10;

-- we'll set the same material for all of them.
mat = standardMaterial()

-- create all chars.
for i = 32 to 126 do (
	char = bit.intAsChar i
	l = text text:char name:(i as string) font:font italic:italic alignment:alignment size:size steps:steps render_mapcoords:true;
	l.material = mat;
	l.pos.x = (i-65) * 60
	l.pos.y = 0
	l.rotation.x_rotation = 90
	addModifier l ex
	ResetXForm l
)